package com.wewebu.ow.server.ao;

import com.wewebu.ow.server.ecm.OwObject;
import com.wewebu.ow.server.exceptions.OwConfigurationException;

/**
 *<p>
 * An configurable application {@link OwObject} provider.  
 * Configuration and initialization is performed considering the {@link OwAOSupport} configuration ,
 * current manager configuration and the context of the provided application objects.
 *</p>
 *
 *<p><font size="-2">
 * Alfresco Workdesk<br/>
 * Copyright (c) Alfresco Software, Inc.<br/>
 * All rights reserved.<br/>
 * <br/>
 * For licensing information read the license.txt file or<br/>
 * go to: http://wiki.alfresco.com<br/>
 *</font></p>
 *@since 4.2.0.0
 */
public interface OwConfigurableSupport
{
    void init(OwSupportConfiguration configuration, OwAOContext context) throws OwConfigurationException;
}
