package com.wewebu.ow.server.ecm;

/**
 *<p>
 * Interface defining the location of or for an object. 
 *</p>
 *
 *<p><font size="-2">
 * Alfresco Workdesk<br/>
 * Copyright (c) Alfresco Software, Inc.<br/>
 * All rights reserved.<br/>
 * <br/>
 * For licensing information read the license.txt file or<br/>
 * go to: http://wiki.alfresco.com<br/>
 *</font></p>
 *@since 4.1.1.0
 */
public interface OwLocation
{
    /**
     * The Resource (Repository/ObjectStore) of the location.
     * @return OwResource
     */
    OwResource getResource();

    /**
     * The parent object, can return null if not filed/contained in a structure.
     * @return OwObject or null.
     */
    OwObject getParent();
}
