package com.wewebu.ow.server.ecm.eaop;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Interfaces  marked with this annotation are considered eaop-advice-interfaces 
 * by the {@link OwAdviser}s.
 * An eaop-advice interface implementation defines ECM related behaviour that is  
 * spread over a number of unrelated methods or modules (native ECM interaction such
 * as native-ECM-search). 
 *    
 *<p><font size="-2">
 * Alfresco Workdesk<br/>
 * Copyright (c) Alfresco Software, Inc.<br/>
 * All rights reserved.<br/>
 * <br/>
 * For licensing information read the license.txt file or<br/>
 * go to: http://wiki.alfresco.com<br/>
 *</font></p>
 *@since 4.0.0.0
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface OwAdvice
{

}
